package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.event.ActionEvent;
import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.*;

public class JLineButton extends JButton {
    
    Image imgGate;
    GraphicsManager refGraphMan;
    
    public JLineButton(Image img) {
        this(img, "");
    }
    
    public JLineButton(Image img, String text) {
        imgGate = img;
        setText(text);
        setSize(40, 50);
        setIcon(new ImageIcon(img.getScaledInstance(36, 36, Image.SCALE_DEFAULT)));
        setDisabledIcon(new ImageIcon(img.getScaledInstance(36, 36, Image.SCALE_DEFAULT)));
        setBorder(null);
        setBackground(new Color(0, 150, 255));
        setOpaque(false);
        setCursor(new Cursor(Cursor.HAND_CURSOR));
        addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                if (getParent() instanceof ToolGateBar && !((ToolGateBar) getParent()).butselected) {
                    ((ToolGateBar) getParent()).butselected = true;
                    refGraphMan.activateLineButton();
                    refGraphMan.setComponentDraggable(false);
                    setOpaque(true);
                }
            }
        });        
    }
    
    public void initializesGraphicsManager(GraphicsManager _g) {
        refGraphMan = _g;
    }
}
