package LCE.view;
import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import javax.swing.*;

public class JSplitMiddlePanel extends JSplitPane{
    
    MiddlePanel MP = new MiddlePanel();
    SouthPanel SP = new SouthPanel(); 
    JScrollPane j = new JScrollPane(MP,ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    
    public JSplitMiddlePanel() {
        setBottomComponent(SP);
        setTopComponent(j);
        setOrientation(JSplitPane.VERTICAL_SPLIT);
        setResizeWeight(0.85);
        setContinuousLayout(true);
        setVisible(true);
    }
    
    public boolean onScreenOfMiddlePanel(JLinkablePanel Jlbl){
        if(Jlbl.getX()+69<j.getViewport().getViewPosition().x+j.getViewport().getWidth() && Jlbl.getY()+69<j.getViewport().getViewPosition().y+j.getViewport().getHeight())
            return true;
        return false;
    } 
    
    //Gli viene passato un MiddlePanel per verificare la sua posizione, e un oggetto Point con le coordinate del cursore nello schermo
    //per effettuare l'autoscroll trascinando una porta
    public void mySetJViewport(MiddlePanel m,Point p,JLinkablePanel g){
        int x = m.getWidth()-j.getViewport().getWidth();
        int y = m.getHeight()-j.getViewport().getHeight();
        j.getViewport().setViewPosition(new Point(x,y));
    }
}