package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.event.ActionEvent;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;

public class JGateButton extends JButton {

    Image imgGate;
    int id;
    GraphicsManager refGraphMan;

    public JGateButton(Image img, int id) {
        this(img, "", id);
    }

    public JGateButton(Image img, String text, int _id) {
        super(text);
        id = _id;
        imgGate = img;
        setSize(36, 24);
        setIcon(new ImageIcon(img.getScaledInstance(36, 24, Image.SCALE_AREA_AVERAGING)));
        setDisabledIcon(new ImageIcon(img.getScaledInstance(36, 24, Image.SCALE_AREA_AVERAGING)));
        setBorder(null);
        setOpaque(false);
        setBackground(new Color(0, 150, 255));
        setCursor(new Cursor(Cursor.HAND_CURSOR));

        addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                if (getParent() instanceof ToolGateBar && !((ToolGateBar) getParent()).butselected) {
                    ((ToolGateBar) getParent()).butselected = true;
                    refGraphMan.setImgGateTmp(imgGate, id);
                    setOpaque(true);
                }
            }
        });
    }
    
    public void initializesGraphicsManager(GraphicsManager _g) {
        refGraphMan = _g;
    }
}
