package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

public class JMenuItemPLAY extends JMenuItem {

    JMenuItemPAUSE pause;
    GraphicsManager refGraphMan;

    public JMenuItemPLAY(String x, JMenuItemPAUSE p) {
        super(x);
        pause = p;
        addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                if (refGraphMan.startSimulate()) {
                    pause.setEnabled(true);
                    ((JMenuItemPLAY) e.getSource()).setEnabled(false);
                    refGraphMan.setCircuitSimulate(true);
                    refGraphMan.clearSelectionMiddlePanel();
                    refGraphMan.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                    refGraphMan.clearSelectionToolBar();
                    refGraphMan.hideInfoGatePanels();
                    refGraphMan.refreshValue();
                    refGraphMan.disableSplitPanelAndToolGateBar();
					refGraphMan.disableButtonTmpMiddlePanel();
                    refGraphMan.refreshMiddlePanel();
					refGraphMan.setMenuEnabled(0, false);

                }
            }
        });
    }

    @Override
    public void setEnabled(boolean x) {
        super.setEnabled(x);
    }

    public void initializesRefGraphicsManager(GraphicsManager _g) {
        refGraphMan = _g;
    }
}
