package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.SwingUtilities;

public class LedPanel extends JLinkablePanel 
{
    Point begin;
    JLinkablePanel link;
    Dimension d;
    URL urlOZero;
    URL urlOUno;
    PopupMenu popupmenu = createPopupMenuLedPanel();
    boolean state = false;

    public LedPanel(int inc, int width, int cont) 
	{
        urlOZero = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/outputzero.gif");
        urlOUno = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/outputuno.gif");
        begin = new Point(width - 20, inc);
        d = new Dimension(20, 20);
        effetiveLink = new Point(width - 20, inc + 10);
        typelink = Input;
        effaceable = false;
        id = cont;
        background = Toolkit.getDefaultToolkit().getImage(urlOZero);
        ci = new char[1];
        ci[0] = '0';
        setPreferredSize(d);
        setBorder(null);
        setOpaque(false);
        setLocation(begin);
        setCursor(new Cursor(Cursor.HAND_CURSOR));

        addMouseListener(new MouseAdapter() 
		{

            @Override
            public void mouseClicked(MouseEvent e) 
			{
                if (SwingUtilities.isRightMouseButton(e)) {
                    popupmenu.show((LedPanel) e.getSource(), e.getX(), e.getY());
                }
                setAndGetEffetiveLink(e.getPoint());
                if (!refGraphMan.isButtonLineActivate() && SwingUtilities.isLeftMouseButton(e)) {
                    selected = !selected;
                    refGraphMan.requestFocusMiddlePanel();
                }

                if (selected  && SwingUtilities.isLeftMouseButton(e)) {
                    refGraphMan.clearSelectionMiddlePanel();
                    refGraphMan.showAliasPanel("Output: " + id);
                    refGraphMan.showInfoGatePanels();
                }

                if (refGraphMan.isButtonLineActivate() && !refGraphMan.isGateTmpActivate() && !refGraphMan.isInputTmpActivate() && linkinput.isEmpty()) {
                    refGraphMan.setJLinkablePanelTmp((LedPanel) e.getSource());
                }

                if (refGraphMan.isButtonLineActivate() && refGraphMan.isGateTmpActivate() && !refGraphMan.isInputTmpActivate() && linkinput.isEmpty()) {
                    refGraphMan.connect((LedPanel) e.getSource());
                    linkinput.add(new LinkInput(getEffettiveLink(), refGraphMan.getLastLinkShape(), 0));
                    refGraphMan.refreshMiddlePanel();
                }

                if (refGraphMan.isButtonLineActivate() && !refGraphMan.isGateTmpActivate() && refGraphMan.isInputTmpActivate() && linkinput.isEmpty()) {
                    refGraphMan.connect((LedPanel) e.getSource());
                    linkinput.add(new LinkInput(getEffettiveLink(), refGraphMan.getLastLinkShape(), 0));
                    refGraphMan.refreshMiddlePanel();
                }
                
                if(refGraphMan.isSpotTmpActivate() && !refGraphMan.isGateTmpActivate() && !refGraphMan.isInputTmpActivate() && linkinput.isEmpty()){
                    refGraphMan.connect((LedPanel) e.getSource());
                    linkinput.add(new LinkInput(getEffettiveLink(), refGraphMan.getLastLinkShape(), 0));
                    refGraphMan.refreshMiddlePanel();
                }
            }
        });
        add(popupmenu);
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(background, 0, 0, this);
    }

    @Override
    protected Point setAndGetEffetiveLink(Point p) 
	{
        effetiveLink = new Point(getX(), getY() + 10);
        if (contains(p)) {
            return effetiveLink;
        }
        return null;
    }

    public void refreshLink() {
        linkinput.get(0).refresh(this, Input);
    }

    @Override
    protected Point getEffettiveLink(int id, boolean typelink) {
        effetiveLink = new Point(getX(), getY() + 10);
        return effetiveLink;
    }

    public void setValueOutput(boolean _state)
	{
        state = _state;
        if(state){
            ci[0] = '1';
            background = Toolkit.getDefaultToolkit().getImage(urlOUno);
        }else{
            ci[0] = '0';
            background = Toolkit.getDefaultToolkit().getImage(urlOZero);
        }
    }
    
    private PopupMenu createPopupMenuLedPanel() 
	{

        PopupMenu p = new PopupMenu();
        MenuItem item1 = new MenuItem("Disconnect");

        item1.addActionListener(new ActionListener() 
		{

            @Override
            public void actionPerformed(ActionEvent e) 
			{
                refGraphMan.isolateJLinkablePanel(id, ((LedPanel) ((PopupMenu) ((MenuItem) e.getSource()).getParent()).getParent()));
            }
        });
        
        p.add(item1);
        return p;
    } 
}
