package LCE;
import LCE.controller.*;
import LCE.model.*;
import LCE.view.*;

public class Startup
{
	//Allocazione del pattern MVC (Model - View - Controller)
	public static GUI window; 	//View
	public static Data data;	//Model
	public static Core core;	//Controller
	
	//Setto il path delle risorse
	public final static String pathMain = "LCE/view/resources/";
	
	public static void main(String[] args)
    {
		//Inizializzo il core
		core = new Core();
		//E mi richiamo il metodo che alloca un thread che gestira' la finestra
		createAndShowGUI();
	}
	
	public static void createAndShowGUI()
	{
		//Lancio un secondo thread che si occupera' di gestire la finestra
		javax.swing.SwingUtilities.invokeLater(
			new Runnable()
			{
				@Override  
				public void run()
				{
					window = new GUI();
				}
			}
		 );	
	}
}