package LCE.model;

public class Input extends Piece
{
	boolean value;
	Link collegamento;
	String name;
	
	public Input(int _x, int _y, String s)
	{
		super(_x, _y);
		collegamento = null;
		if (s!="") name = s;
		else name = "X" + super.getID();
	}
	
	public Input(int _x, int _y){
		this(_x, _y,"");
	}
	
	public void setName(String s)
	{
		name = s;
	}
	
	public String getName()
	{
		return name;
	}
	
	public boolean getOutput()
	{
		return value;
	}
	
	public boolean getInput(int idPed)
	{
		return value;
	}
	
	public void setLink(Link l)
	{
		collegamento = l;
	}
	
	public void setInput(int _id, boolean in)
	{
		value = in;
	}
	
	public void refreshValue()
	{
		if(collegamento != null)
		{ 
			collegamento.valIn = getOutput();
			collegamento.refresh();
		}
	}
}