package LCE.model;

class NAndGate extends Gate
{
	boolean[] pinI;
	boolean pinO;
	
	public NAndGate(int _x, int _y)
	{
		super(_x, _y);
		pinI = new boolean[2];
		pinI[0] = pinI[1] = pinO = false;
	}
	
	public boolean getInput(int index)
	{
		return pinI[index];
	}
	
	public void setInput(int index, boolean _in)
	{
		pinI[index] = _in;	
	}
	
	public boolean getOutput()
	{
		return pinO;
	}
	
	public void refreshValue()
	{
		pinO = !( pinI[0] && pinI[1] );
		super.refreshOutput();
	}
}