package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import sun.awt.CustomCursor;

public class JRubberButton extends JButton{

    Image imgButton;
    Cursor custom;
    GraphicsManager refGraphMan;
    
    public JRubberButton(Image img) {
        imgButton = img;
        custom = Toolkit.getDefaultToolkit().createCustomCursor(imgButton,new Point(3,29),"");
        setSize(40, 50);
        setIcon(new ImageIcon(img.getScaledInstance(36, 36, Image.SCALE_DEFAULT)));
        setDisabledIcon(new ImageIcon(img.getScaledInstance(36, 36, Image.SCALE_DEFAULT)));
        setBorder(null);
        setOpaque(false);
        setBackground(new Color(0, 150, 255));
        setCursor(new Cursor(Cursor.HAND_CURSOR));
        
        addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                if(getParent() instanceof ToolGateBar && !((ToolGateBar)getParent()).butselected){
                    ((ToolGateBar)getParent()).butselected = true;
                    refGraphMan.setCursor(custom);
                    refGraphMan.activateRubberButton();
                    setOpaque(true);
                }
            }
        });
    }

    public void initializesGraphicsManager(GraphicsManager _g) {
        refGraphMan = _g;
    }
}
