package LCE.model;
import LCE.*;
import LCE.controller.*;
import LCE.view.*;

public abstract class Piece{
	protected int ID;//Chaive primaria della porta
	protected static int numComp = 0;
	public int  x;
	public int y;
	
	public Piece(int _x, int _y){
		ID=numComp;
		numComp++;
		this.x = _x;
		this.y = _y;
	}
	
	public int getID(){
		return ID;
	}
	
	public void movePiece(int _x, int _y){
		this.x = _x;
		this.y = _y;
	}
	
	public boolean equals(Piece t){
		if(t.getID() == this.ID)
			return true;
		return false;
	}
	
	public String toString(){
		return "Porta: " + this.getClass() + "Coord: [" + x + "," + y + "] ID: "+ this.ID + " valore di uscita:"+ this.getOutput();
	}
	
	abstract public boolean getInput(int idPed);
	abstract public void refreshValue();//Aggiorna output
	abstract public boolean getOutput();
	abstract public void setInput(int idIn, boolean value);
}
	
	
	