package LCE.model;


class Point extends Piece 
{

    boolean input;
    public Link[] collegamenti;
    
    public Point(int _x, int _y) 
    {
        super(_x, _y);
        input = false;
        collegamenti = new Link[2];
    }

    public boolean contain(Link l) 
    {
        for(int i = 0; i < collegamenti.length; i++)
		{
            if(collegamenti[i] != null && collegamenti[i].equals(l)){
                return true;
			}
		}
        return false;
    }

    public boolean addLink(Link l, int idIn) 
    {
        if (l != null && collegamenti[idIn] == null) 
        {
            collegamenti[idIn] = l;
            return true;
        }
        return false;
    }

    public void deleteLink(Link l) 
    {
        if (l != null)
        {
            int i = 0;
            while(i < collegamenti.length)
            {
                if(collegamenti[i] != null && collegamenti[i].equals(l))
                    collegamenti[i] = null;
				i++;
            }
        }
    }

    @Override
    public boolean getOutput() 
	{
        return input;
    }

    @Override
    public void setInput(int idIn, boolean value) 
	{
        input = value;
        return;
    }

    @Override
    public void refreshValue() 
	{
			for (int i = 0; i < collegamenti.length; i++) 
			{
				if(collegamenti[i] != null)
				{
					collegamenti[i].valIn = getOutput();
					collegamenti[i].refresh();
				}
			}
    }

    @Override
    public boolean getInput(int index) 
	{
            return input;
    }
}