package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.net.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.Popup;
import javax.swing.SwingUtilities;

public class InputPanel extends JLinkablePanel 
{
    Point begin;
    Point end;
    Dimension d;
    URL urlZero;
    URL urlUno;
    public boolean state = false;
    public JTextField textlabel;
    PopupMenu popupmenu = createPopupMenuInputPanel();

    public InputPanel(int inc, int _id) {
        urlZero = refGraphMan.getURLResource("img/zero.gif");
        urlUno = refGraphMan.getURLResource("img/uno.gif");
        begin = new Point(0, inc);
        end = new Point(40, inc);
        d = new Dimension(40, 20);
        effetiveLink = new Point(40, inc + 19);
        typelink = Output;
        background = Toolkit.getDefaultToolkit().getImage(urlZero);
        effaceable = false;
        id = _id;
        co = new char[1];
        co[0] = '0';
        textlabel = new MYJTextField(id);
        textlabel.setOpaque(false);
        textlabel.setBorder(null); 
        setPreferredSize(d);
        setBorder(null);
        setLocation(begin);
        setOpaque(false);
        setCursor(new Cursor(Cursor.HAND_CURSOR));

        addMouseListener(new MouseAdapter() 
		{

            @Override
            public void mouseClicked(MouseEvent e) 
			{
                if (SwingUtilities.isRightMouseButton(e)) 
				{
                    popupmenu.show((InputPanel) e.getSource(), e.getX(), e.getY());
                }
                setAndGetEffetiveLink(e.getPoint());
                if (!refGraphMan.isButtonLineActivate()) 
				{
                    selected = !selected;
                    refGraphMan.requestFocusMiddlePanel();
                }

                //Seleziona il panel
                if (selected && SwingUtilities.isLeftMouseButton(e)) 
				{
                    refGraphMan.clearSelectionMiddlePanel();
                    refGraphMan.showAliasPanel("Input: " + id);
                    refGraphMan.showInfoGatePanels();
                }

                if(	refGraphMan.isButtonLineActivate() &&
                   	!refGraphMan.isGateTmpActivate() &&
                   	!refGraphMan.isOutputTmpActivate() &&
                   	!refGraphMan.isSpotTmpActivate() &&
                   	linkoutput.isEmpty()
				)	
					refGraphMan.setJLinkablePanelTmp((InputPanel) e.getSource());
               

                if (!refGraphMan.isButtonLineActivate() && SwingUtilities.isLeftMouseButton(e)) {
                    state = !state;
                    refGraphMan.setInputInModel(id, state);
                    if (state) {
                        background = Toolkit.getDefaultToolkit().getImage(urlUno);
                        co[0] = '1';
                    } else {
                        background = Toolkit.getDefaultToolkit().getImage(urlZero);
                        co[0] = '0';
                    }

                    refGraphMan.refreshAliasPanel(((InputPanel)e.getSource()).id);
                    refGraphMan.refreshValue();
                    refGraphMan.refreshAliasPanel(id);
                    repaint();
                }

                if ((refGraphMan.isGateTmpActivate()
                        ^ refGraphMan.isOutputTmpActivate())
                        && refGraphMan.isButtonLineActivate() && linkoutput.isEmpty()) {
                    refGraphMan.connect((InputPanel) e.getSource());
                    linkoutput.add(new LinkOutput(getEffettiveLink(), refGraphMan.getLastLinkShape(), 0));
                    refGraphMan.refreshMiddlePanel();
                }
            }
        });
        add(popupmenu);
    }

    @Override
    protected Point setAndGetEffetiveLink(Point p) {
        if (contains(p));
        return effetiveLink;
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(background, 0, 0, null);
    }

    @Override
    protected Point getEffettiveLink(int id, boolean typelink) {
        return effetiveLink;
    }

    private PopupMenu createPopupMenuInputPanel() {

        PopupMenu p = new PopupMenu();
        MenuItem item1 = new MenuItem("Disconnect");

        item1.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                refGraphMan.isolateJLinkablePanel(id,((InputPanel) ((PopupMenu) ((MenuItem) e.getSource()).getParent()).getParent()));
            }
        });

        p.add(item1);
        return p;
    }
}

class MYJTextField extends JTextField {

    public int idinput;

    public MYJTextField(int id) {
        idinput = id;
    }
}
