package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

public class JMenuItemPAUSE extends JMenuItem 
{
    JMenuItemPLAY play;
    GraphicsManager refGraphMan;

    public JMenuItemPAUSE(String x) 
	{
        super(x);
        addActionListener(new ActionListener() 
		{
            @Override
            public void actionPerformed(ActionEvent e) 
			{
                if (refGraphMan.stopSimulate()) 
				{
                    play.setEnabled(true);
                    ((JMenuItemPAUSE) e.getSource()).setEnabled(false);
                    refGraphMan.setCircuitSimulate(false);
                    refGraphMan.clearSelectionMiddlePanel();
                    refGraphMan.hideInfoGatePanels();
                    refGraphMan.enableSplitPanelAndToolGateBar();
                    refGraphMan.refreshMiddlePanel();
					refGraphMan.setMenuEnabled(0, true);
                }
            }
        });
    }

    public void setPlay(JMenuItemPLAY _play) {
        play = _play;
    }

    @Override
    public void setEnabled(boolean x) {
        super.setEnabled(x);
    }
    
    public void initializesRefGraphicsManager(GraphicsManager _g){
        refGraphMan = _g;
    }
}
